/**
 * Copyright (c) 2005 Daffodil Software Ltd all rights reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * There are special exceptions to the terms and conditions of the GPL
 * as it is applied to this software. See the GNU General Public License for more details.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

function addColumn()
{
   var selectbox=document.getElementById("leftList");
    if(selectbox.selectedIndex==-1){
         alert("Select an Item to Move");
         return false;
    }
    else{
   var selectItem=selectbox.selectedIndex;
   var output=selectbox.options[selectItem].text;
   if(selectItem<0)
   return false;
   var rightLength =document.getElementById("rightList").length;
   document.getElementById("rightList").options[rightLength] = new Option(output,output);
   selectbox.options[selectItem]=null;
   var lengthAfterRemove=selectbox.length;
   if(lengthAfterRemove>0 && lengthAfterRemove -1 < selectItem){
   	selectbox.selectedIndex= (selectItem -1);
      	selectbox.options[selectItem -1].selected;
   }
   else
   	selectbox.selectedIndex=selectItem;
   }
}

function deleteColumn()
{
    var selectbox=document.getElementById("rightList");
    if(selectbox.selectedIndex==-1){
         alert("Select an Item to Move");
         return false;
    }
    else{
    var output=selectbox.options[selectbox.selectedIndex].text;
    var selectItem=selectbox.selectedIndex;
    if(selectItem<0)
    return false;
    var leftLength =document.getElementById("leftList").length;
    document.getElementById("leftList").options[leftLength] = new Option(output,output);
    selectbox.options[selectItem]=null;
    var lengthAfterRemove=selectbox.length;
    if(lengthAfterRemove>0 && lengthAfterRemove -1 < selectItem){
    	   selectbox.selectedIndex= (selectItem -1);
           selectbox.options[selectItem -1].selected;
    }
    else
           selectbox.selectedIndex=selectItem;
    }
}

function moveUpColumn()
{
    var selectbox=document.getElementById("rightList");
    var index=selectbox.selectedIndex;
    if(index==-1){
         alert("Select an Item to Move");
         return false;
    }
    else if(index==0)
     return false;
    else{
    var textFirst=selectbox.options[index].text;
    var textSecond=selectbox.options[index-1].text;
    selectbox[index].text=textSecond;
    selectbox[index-1].text=textFirst;
    selectbox.selectedIndex=index-1;
}
}

function moveDownColumn()
{
    var selectbox=document.getElementById("rightList");
    var length=selectbox.length;
     if(selectbox.selectedIndex==-1){
         alert("Select an Item to Move");
         return false;
    }
    else if(selectbox.selectedIndex==length-1)
    return false;
    else{
    var selectItem=selectbox.selectedIndex;
    var textFirst=selectbox.options[selectItem].text;
    var textSecond=selectbox.options[selectItem+1].text;
    selectbox[selectItem].text=textSecond;
    selectbox[selectItem+1].text=textFirst;
    selectbox.selectedIndex=selectItem+1;
}
}

function setSelectionInHidden()
{
    var rightCombo =document.getElementById("rightList");
    var rightOptions =rightCombo.options;
    var s = "";
    for (var i = 0; i < rightCombo.length; i++) {
    if(i !=0)
    	s=s+",";
      	s =s + rightOptions[i].text;
    }
    if(s.length >0)
        document.getElementById("field").value = "Select Id," + s;

//
//        alert("method called")
        var firstColumn=document.getElementById("firstColumn");
  	var firstValue=firstColumn.options[firstColumn.selectedIndex].text;

        var secondColumn=document.getElementById("secondColumn");
  	var secondValue=secondColumn.options[secondColumn.selectedIndex].text;
        var thirdColumn=document.getElementById("thirdColumn");
  	var thirdValue=thirdColumn.options[thirdColumn.selectedIndex].text;
        var fourthColumn=document.getElementById("fourthColumn");
  	var fourthValue=fourthColumn.options[fourthColumn.selectedIndex].text;
//          alert("secondValue="+secondValue);
           if((firstValue=="None" && secondValue!="None")||(firstValue=="None" && thirdValue!="None")||(firstValue=="None" && fourthValue!="None")){
		alert("Firstly select first combo for sorting");
                return false;
           }
}

function addCondition()
{
    document.getElementById("conditionCombo").options.length=0;
    var combo = document.getElementById("column");
    var columnText = combo.options[combo.selectedIndex].text;
    var columnValue = combo.options[combo.selectedIndex].value;
    columnValue=columnValue.toLowerCase();
    var conditionArrayFirst=new Array("=","!=",">","<","<=",">=");
    var conditionArraySecond=new Array("=","!=");
    document.getElementById("textSecond").value="";
    if((columnValue=="char")||(columnValue=="varchar"))
    {
    	var relation=document.getElementById("conditionCombo");
    	relation.options.add(new Option("=","="));
    	relation.options.add(new Option("!=","!="));
    }
    else
    {
    	var relation=document.getElementById("conditionCombo");
    	relation.options.add(new Option("=","="));
    	relation.options.add(new Option("!=","!="));
    	relation.options.add(new Option("<","<"));
    	relation.options.add(new Option("<=","<="));
    	relation.options.add(new Option(">",">"));
    	relation.options.add(new Option(">=",">="));
        if(columnValue=="date")
        {
          var date=new Date();
          var newDate="";
	    newDate+=date.getYear()+"-";
            var month=date.getMonth();
            if(month<9)
            {

	    newDate+="0"+(month+1)+"-";
            }
            else
            {
              newDate+=(month+1)+"-";
            }
	    newDate+=date.getDate();

          document.getElementById("textSecond").value=newDate;
        }
    }
    if(columnText=="PrimaryOwner")
    {
      document.getElementById("layer2").style.visibility ='visible';
      document.getElementById("layer3").style.visibility ='hidden';
      document.getElementById("layer4").style.visibility ='hidden';
      document.getElementById("layer1").style.visibility ='hidden';
      document.getElementById("layer5").style.visibility ='hidden';
    }
    else if (columnText=="Status")
    {
      document.getElementById("layer3").style.visibility ='visible';
      document.getElementById("layer2").style.visibility ='hidden';
      document.getElementById("layer4").style.visibility ='hidden';
      document.getElementById("layer1").style.visibility ='hidden';
      document.getElementById("layer5").style.visibility ='hidden';
    }
    else if (columnText=="Category")
    {
      document.getElementById("layer4").style.visibility ='visible';
      document.getElementById("layer2").style.visibility ='hidden';
      document.getElementById("layer3").style.visibility ='hidden';
      document.getElementById("layer1").style.visibility ='hidden';
      document.getElementById("layer5").style.visibility ='hidden';
    }
    else if (columnText=="SalesStage")
    {
      document.getElementById("layer5").style.visibility ='visible';
      document.getElementById("layer2").style.visibility ='hidden';
      document.getElementById("layer3").style.visibility ='hidden';
      document.getElementById("layer1").style.visibility ='hidden';
      document.getElementById("layer4").style.visibility ='hidden';
    }
    else
    {
      document.getElementById("layer1").style.visibility ='visible';
      document.getElementById("layer2").style.visibility ='hidden';
      document.getElementById("layer3").style.visibility ='hidden';
      document.getElementById("layer4").style.visibility ='hidden';
      document.getElementById("layer5").style.visibility ='hidden';
    }
    document.getElementById("conditionCombo").disabled=null;
    document.getElementById("textSecond").disabled=null;
}

  function addText()
  {
    var combo = document.getElementById("testCombo");
    var id = combo.options[combo.selectedIndex].value;
    document.getElementById("layer2").style.visibility ='visible';
    document.getElementById("layer3").style.visibility ='hidden';
    document.getElementById("layer4").style.visibility ='hidden';
    document.getElementById("layer5").style.visibility ='hidden';
    document.getElementById("layer1").style.visibility ='hidden';
    document.getElementById("textSecond").value=id;
    document.getElementById("testCombo").disabled=null;
   }

  function addStatus()
  {
    var combo=document.getElementById("statusCombo");
    var id = combo.options[combo.selectedIndex].value;
    document.getElementById("layer3").style.visibility ='visible';
    document.getElementById("layer2").style.visibility ='hidden';
    document.getElementById("layer4").style.visibility ='hidden';
    document.getElementById("layer5").style.visibility ='hidden';
    document.getElementById("layer1").style.visibility ='hidden';
    document.getElementById("textSecond").value=id;
    document.getElementById("statusCombo").disabled=null;
  }

  function addCategory()
  {
    var combo=document.getElementById("categoryCombo");
    var id = combo.options[combo.selectedIndex].value;
    document.getElementById("layer4").style.visibility ='visible';
    document.getElementById("layer5").style.visibility ='hidden';
    document.getElementById("layer3").style.visibility ='hidden';
    document.getElementById("layer2").style.visibility ='hidden';
    document.getElementById("layer1").style.visibility ='hidden';
    document.getElementById("textSecond").value=id;
    document.getElementById("statusCombo").disabled=null;
  }

   function addSalesStage()
  {
    var combo=document.getElementById("salesStageCombo");
    var id = combo.options[combo.selectedIndex].value;
    document.getElementById("layer5").style.visibility ='visible';
    document.getElementById("layer4").style.visibility ='hidden';
    document.getElementById("layer3").style.visibility ='hidden';
    document.getElementById("layer2").style.visibility ='hidden';
    document.getElementById("layer1").style.visibility ='hidden';
    document.getElementById("textSecond").value=id;
    document.getElementById("statusCombo").disabled=null;
  }

function addToList(){
   var combo = document.getElementById("column");
   var columnText = combo.options[combo.selectedIndex].text;
   var columnValue = combo.options[combo.selectedIndex].value;
   var secondValue = document.getElementById("conditionCombo");
   var selectedValue = secondValue.options[secondValue.selectedIndex].text;
   var thirdValue = document.getElementById("textSecond").value;
   columnValue=columnValue.toLowerCase();
   if(thirdValue==null || thirdValue.length<=0){
	alert("Value Field Cann't be left blank")
        return false;
   }
   else
   {
//     if((columnValue=="char")||(columnValue=="varchar"))
//            	{
//
//      			if(isNaN(thirdValue)){
//      			return true;
//    			}
//                            else{
//                              alert("Value you entered in not a string");
//                              return false;
//                            }
//
//      		}
//                else if((columnValue=="int")||(columnValue=="smallint")||(columnValue=="decimal"))
//                {
//                  if(!isNaN(thirdValue)){
//                    return true;
//                  }
//                   else{
//                   	alert("Value you entered in not a number");
//                      	return false;
//                  }
//                }
    if((columnValue=="char")||(columnValue=="varchar"))
    {
      	thirdValue="'"+thirdValue+"'";
    }
    else if(columnValue=="date")
    {
     thirdValue="date'"+thirdValue+"'"
    }
   var listLength= document.getElementById("queryList").length;
   var itemLength=columnText.length;
   if(itemLength ==0){
    	document.getElementById("conditionCombo").disabled="true";
    	document.getElementById("textSecond").disabled="true";
    	return;
   }
   var output=columnText;
   while(output.length<30)
   {
     output+=" ";
   }
    output += selectedValue+"     "+ thirdValue;
    document.getElementById("queryList").options[listLength] = new Option(output,output);
    document.getElementById("querytext").value=createQuery();
    document.getElementById("column").value="";
    document.getElementById("conditionCombo").value="";
    document.getElementById("textSecond").value="";
    document.getElementById("testCombo").value="";
    document.getElementById("statusCombo").value="";
    document.getElementById("categoryCombo").value="";
    document.getElementById("salesStageCombo").value="";
  }
}

function createQuery()
{
  var list=document.getElementById("queryList");
 var length= list.options.length;
 if(length>0)
 {
   var query="where ";
   var i=0;
  for(i=0;i<length-1;i++)
  {
   query+= ignoreSpaces(list.options[i].value)+" and ";
  }
  query+=ignoreSpaces(list.options[i].value);
  return query;
 }
  return "";
}

function ignoreSpaces(string)
{
    var temp = "";
    string = '' + string;
    splitstring = string.split(" ");
    for(i = 0; i < splitstring.length; i++)
    {
    if(trim(splitstring[i]).length>0)
    {
	temp += splitstring[i]+" ";
    }
    }
    return temp;
}

function removeFromList()
{
  var removeItem=document.getElementById("queryList");
  if(removeItem.selectedIndex==-1){
  alert("Select an Item to remove");
  return false;
  }
  else{
  var removeValue=removeItem.options[removeItem.selectedIndex].text;
  var removeIndex=removeItem.selectedIndex;
  removeItem.options[removeIndex]=null;
  queryItem =document.getElementById("querytext").value=createQuery();
 }
}

function setTableNameInHidden(){
    var tableName =document.getElementById("tableName");
    var tableSelected=tableName.options[tableName.selectedIndex].value;
    document.getElementById("table").value=tableSelected;
    document.leadTable.submit();
}

function trim(s)
{
       while ((s.substring(0,1) == ' ') || (s.substring(0,1) == '\n') || (s.substring(0,1) == '\r'))
  {
    s = s.substring(1,s.length);
  }

  // Remove trailing spaces and carriage returns

  while ((s.substring(s.length-1,s.length) == ' ') || (s.substring(s.length-1,s.length) == '\n') || (s.substring(s.length-1,s.length) == '\r'))
  {
    s = s.substring(0,s.length-1);
  }
  return s;
}
