<%--
 * Copyright (c) 2005 Daffodil Software Ltd all rights reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * There are special exceptions to the terms and conditions of the GPL
 * as it is applied to this software. See the GNU General Public License for more details.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
--%>

<%@ page import="java.util.*, java.sql.*, sourceleads.*,javax.servlet.http.*" errorPage="errorpage.jsp"%>
<html>
<head>
<title>
Edit Interaction
</title>
<LINK media="all" type="text/css" href="themes/leads/style.css" rel="stylesheet">
<link media="all" type="text/css" rel="stylesheet" href="script/calendar/calendar-win2k-cold-2.css" title="win2k-cold-2">

<!-- import the calendar script -->
<script type="text/javascript" src="script/calendar/calendar.js"></script>

<!-- import the language module -->
<script type="text/javascript" src="script/calendar/calendar-en.js"></script>

<script type="text/javascript" src="script/calendar/calendarHelper.js"></script>
<script type="text/javascript">
function checkDate(form)
{
  var date=form.T1.value;
  date=trim(date);
  if(date.length==0)
  {
  alert("Date field can't left blank");
  return false;
  }
  var time=form.time.value;
  time=trim(time);
  if(time.length==0)
  {
  alert("Time field can't left blank");
  return false;
  }
  return true;
}
function trim(s)
{
       while ((s.substring(0,1) == ' ') || (s.substring(0,1) == '\n') || (s.substring(0,1) == '\r'))
  {
    s = s.substring(1,s.length);
  }

  // Remove trailing spaces and carriage returns

  while ((s.substring(s.length-1,s.length) == ' ') || (s.substring(s.length-1,s.length) == '\n') || (s.substring(s.length-1,s.length) == '\r'))
  {
    s = s.substring(0,s.length-1);
  }
  return s;
}
</script>
</head>
<body >
  <%
  	Object userName=session.getAttribute("userLoginValue");
       ConnectionProvider connectionProvider=(ConnectionProvider)session.getAttribute("ConnectionProvider");
      	if(connectionProvider==null)
       {
      		%><jsp:forward page="HeaderMediator.jsp" /><%
       }
       	Connection connection =connectionProvider.getConnection();
  	String id=request.getParameter("interactionId");
      	String selectBox=request.getParameter("selectBox");
      	String item=request.getParameter("item");
	String heading=null;
        if(item.equals("Nonmail"))
        {
        heading="Non+EMail+Interactions";
        }
        else if(item.equals("Mail"))
        {
        heading="EMail+Interactions";
        }
        else
        {
        heading="All+Interactions";
        }

	Statement stmt = connection.createStatement();
	ResultSet rs1 =  stmt.executeQuery("select * from interactiondetails where id="+id);
        if(rs1.next()){
		String interactionDate[]=rs1.getString(3).split(" ");
		String type=rs1.getString(4);
		String Remarks =rs1.getString(5);
		String Status =rs1.getString(6);
		String Caller =rs1.getString(7);
		String FinalResult=rs1.getString(8);
		String Subject =rs1.getString(9);
                String SalesStage =rs1.getString(10);
		double SalesPotential=rs1.getDouble(11);

  %>
<table cellspacing="0" cellpadding="0" border="0" width="100%" class="link">
	<tr height="20" class="otherTab" >
        <td style="padding-left:7px;">&nbsp;</td>
        <td nowrap><a  target="_top" class="otherTab" href="displayhistory.jsp?page=addaction.jsp&interactionbutton=Add+Action&heading=Add+Action&selectBox=<%=selectBox%>">Add Action</a></td>
        <td style="padding-left:7px;">&nbsp;</td>
        <td nowrap><a  target="_top" class="otherTab" href="displayhistory.jsp?page=actionhistory.jsp&actionbutton=...&heading=Action+Details&selectBox=<%=selectBox%>">Action Details</a></td>
        <td style="padding-left:7px;">&nbsp;</td>
        <td nowrap><a  target="_top" class="otherTab" href="InteractionFrame.jsp?page=InteractionRecords.jsp&selectBox=<%=selectBox%>&item=All&heading=Interaction+Details">Interaction Details</a></td>
        <td width="100%">&nbsp;</td>
	</tr>
  </table>
  <br />
<form method="post" action="displayhistory.jsp?page=InteractionRecords.jsp&heading=<%=heading%>&interactionId=<%=id%>&selectBox=<%=selectBox%>&item=<%=item%>" target="_top">

<center>
<table bgcolor="black" cellpadding="0" cellspacing="1">
 <tr class="head">
  <td>
  <table border="0" cellspacing="0" cellpadding="3" width="100%">
   <tr>
    <td NOWRAP>Subject</td>
    <td colspan="3"><input type="text" name="subject"  size="80" value="<%=(Subject==null || Subject.length()==0)?"&nbsp;":Subject%>"></td>
   </tr>

 <tr>
   <td NOWRAP align="left" colspan="4">Remarks</td>
   </tr>
   <tr>
   <td colspan="4"><textarea rows="6" cols="75" name="TA1" ><%=(Remarks==null || Remarks.length()==0)?"&nbsp;":Remarks%></textarea></td>
</tr>

   <tr>
	<td NOWRAP>Type</td>
        <td><select name="C1">
            <option value="">--Choose One--</option>
   <%
         ResultSet rsType=stmt.executeQuery("select * from types");
  	 while(rsType.next()){
             String typeName=rsType.getString("name");
              if(type!=null && type.equalsIgnoreCase(typeName)){%>
        	<option selected="selected"><%=typeName%></option><%
        	}
		else{%>
		<option><%=typeName%></option><%
               }
  	 }
           rsType.close();
  %>
       </select></td>
       <td NOWRAP>Result</td>
       <td><select name="result">
           <%
        String[] allResult=new String[]{"Unknown","Successful","Fail"};
        for (int i = 0; i < allResult.length; i++) {
	 if(FinalResult!=null && FinalResult.equalsIgnoreCase(allResult[i])){%>
  		<option selected="selected"><%=allResult[i]%></option><%
        	}
		else{%>
		<option><%=allResult[i]%></option><%
               }
	}
      %>
        </select></td>
        </tr>

	<tr>
	 <td NOWRAP>Caller</td>
	 <td NOWRAP><select name="C3">
     <!-- [User list from Users] -->
	<%
	ResultSet rsCaller =  stmt.executeQuery("select id, loginId from users");
	while(rsCaller.next()){
	   int id0 = rsCaller.getInt(1);
           String loginId0 = rsCaller.getString(2);
           	 if(Caller!=null && Caller.equalsIgnoreCase(String.valueOf(id0))){%>
        	<option selected="selected" value="<%=id0%>"><%=loginId0%></option><%
        	}
		else{%>
        	<option value="<%=id0%>"><%=loginId0%></option><%
               }
	}
        rsCaller.close();
	%>
        </select></td>
       <td NOWRAP>Status</td>
       <td><select name="C2">
       <option value="">--Choose One--</option>
   <%
         ResultSet rsStatus=stmt.executeQuery("select * from status");
  	 while(rsStatus.next()){
             String statusName=rsStatus.getString("statusname");
              if(Status!=null && Status.equalsIgnoreCase(statusName)){%>
        	<option selected="selected"><%=statusName%></option><%
        	}
		else{%>
		<option><%=statusName%></option><%
               }
  	 }
           rsStatus.close();
  %>
	</select> </td>
       </tr>

	<tr>
	<td NOWRAP>Business Potential</td>
	<td ><input type="text" name="salesPotential" value="<%=SalesPotential%>"></td>
          <!-- sales stage work-->
        <td nowrap>Sales Stage</td>
        <td >
        <select size="1" name="salesStage" >
          <option value="">--Choose One--</option>
  <%
	ResultSet rsStage =  stmt.executeQuery("select * from SalesStage");
        while(rsStage.next()){
         	String stageName = rsStage.getString("StageName");
              	String stageRank = rsStage.getString("StageRank");
              if(SalesStage!=null && SalesStage.equalsIgnoreCase(stageName)){%>
        	<option selected="selected"><%=stageName%></option><%
        	}
		else{%>
		<option><%=stageName%></option><%
               }
	}
        rsStage.close();
   %>
      </select></td>
</tr>

<tr>
	<td NOWRAP>Date</td>
	<td >
         <input type="text" name="T1" readonly="readonly" size="13" value="<%=interactionDate[0]%>">
         <input class="reset" type="reset" value="" onclick="return showCalendar('T1', 'y-mm-dd');">
        </td>
        <td>
          Time
        </td>
        <td>
         <%
         String interactionTime[]=interactionDate[1].split(":");
		int hours=Integer.parseInt(interactionTime[0]);
                int minutes=Integer.parseInt(interactionTime[1]);
         %>HH
          <select name="hours">
            <%
            for(int i=0;i<24;i++)
            {
              if(hours==i)
              {
            %>
            <option selected="selected" value="<%=i%>"><%=i%></option>
            <%
            }
            else
            {
            %>
            <option value="<%=i%>"><%=i%></option>
            <%
            }
            }
            %>
          </select>
          MM
          <select name="minutes">
            <%
            for(int i=0;i<60;i++)
            {
              if(minutes==i)
              {
            %>
            <option selected="selected" value="<%=i%>"><%=i%></option>
            <%
            }
            else
            {
            %>
            <option value="<%=i%>"><%=i%></option>
            <%
            }
            }
            %>
            </select>
        </td>
</tr>
   <tr class="head">
     <td colspan="4">&nbsp;
     </td>
   </tr>
<tr class="head">
  <td colspan="4" align="center">
	<input class="submit"  type="submit" value="Save" name="updateinteractionbutton">
        <input class="submit" type="submit" value="Cancel" name="updateinteractionbutton">
  </td>
</tr>
</table>
</td></tr>
</table>
</center>
        <%}
        rs1.close();
        stmt.close();%>
</form>
</body>
</html>
